#include <bits/stdc++.h>

using namespace std;

set<int> used, unused;
int n, m;
long long s;
vector<vector<long long>> a;

void rec2(int i, long long d[], long long sum) {
    if (i == m) {
        if (sum == s) {
            cout << "YES\n";
            cout << used.size() + unused.size() << '\n';
            for (auto x: used) {
                cout << 1 << " " << x + 1 << '\n';
            }
            for (auto x: unused) {
                cout << 2 << " " << x + 1 << '\n';
            }
            exit(0);
        }
        return;
    }
    rec2(i + 1, d, sum + d[i]);
    unused.insert(i);
    rec2(i + 1, d, sum);
    unused.erase(i);
}

void rec(int i) {
    if (i == n) {
        long long d[m];
        for (int j = 0; j < m; ++j) {
            long long sum = 0;
            for (int k = 0; k < n; ++k) {
                if (used.find(k) == used.end()) sum += a[k][j];
            }
            d[j] = sum;
        }
        rec2(0, d, 0);
        return;
    }
    rec(i + 1);
    used.insert(i);
    rec(i + 1);
    used.erase(i);
}

void cer2(vector<long long> d) {
    bool dp[n + 1][s + 1];
    pair<int, int> parent[n + 1][s + 1];
    for (int i = 0; i <= n; ++i) {
        for (int j = 0; j <= s; ++j) {
            dp[i][j] = false;
        }
    }
    for (int i = 0; i <= n; ++i) {
        dp[i][0] = true;
    }
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j <= s; ++j) {
            if (j - d[i - 1] >= 0) {
                if (dp[i - 1][j - d[i - 1]]) {
                    dp[i][j] = true;
                    parent[i][j] = {i - 1, j - d[i - 1]};
                }
            }
            if (dp[i - 1][j]) {
                dp[i][j] = true;
                parent[i][j] = {i - 1, j};
            }
        }
    }
    if (dp[n][s]) {
        cout << "YES\n";
        stack<int> ans;
        int i = n;
        long long j = s;
        while (j != 0) {
            if (parent[i][j].second == j) {
                ans.push(i);
            }
            int t = i;
            i = parent[i][j].first;
            j = parent[t][j].second;
        }
        cout << used.size() + ans.size() << '\n';
        for (auto x: used) {
            cout << 1 << " " << x << '\n';
        }
        while (!ans.empty()) {
            cout << 2 << " " << ans.top() << '\n';
            ans.pop();
        }
        exit(0);
    }
}

void cer(int i) {
    if (i == n) {
        vector<long long> d(m);
        for (int j = 0; j < m; ++j) {
            long long sum = 0;
            for (int k = 0; k < n; ++k) {
                if (used.find(k) == used.end()) sum += a[k][j];
            }
            d[j] = sum;
        }
        cer2(d);
        return;
    }
    cer(i + 1);
    used.insert(i);
    cer(i + 1);
    used.erase(i);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n);
    bool t = true, f = true;
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
        long long sum = 0;
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
            sum += a[i][j];
            if (a[i][j] > 6) {
                f = false;
            }
        }
        if (sum > i + 1) {
            t = false;
        }
    }
    cin >> s;
    if (t) {
        for (int aa = 0; aa < n; ++aa) {
            for (int b = aa; b < n; ++b) {
                for (int c = 0; c < m; ++c) {
                    for (int d = 0; d < m; ++d) {
                        long long sum = 0;
                        for (int i = aa; i <= b; ++i) {
                            for (int j = c; j <= d; ++j) {
                                sum += a[i][j];
                            }
                        }
                        if (sum == s) {
                            cout << "YES\n";
                            cout << (n + m) - (b - aa + 1) - (d - c + 1) << '\n';
                            for (int i = 0; i < aa; ++i) {
                                cout << 1 << " " << (i + 1) << '\n';
                            }
                            for (int i = b + 1; i < n; ++i) {
                                cout << 1 << " " << (i + 1) << '\n';
                            }
                            for (int i = 0; i < c; ++i) {
                                cout << 2 << " " << (i + 1) << '\n';
                            }
                            for (int i = d + 1; i < m; ++i) {
                                cout << 2 << " " << (i + 1) << '\n';
                            }
                            return 0;
                        }
                    }
                }
            }
        }
    } else if (f) {
        if (s > n * m * 6) {
            cout << "NO";
            return 0;
        } else {
            cer(0);
        }
    } else {
        rec(0);
    }
    cout << "NO";
    return 0;
}