#include <bits/stdc++.h>

using namespace std;

set<int> used, unused;
int n, m;
long long s;
vector<vector<long long>> a;

void check(long long d[]) {
    long long sum = 0;
    for (int i = 0; i < m; ++i) {
        if(unused.find(i) == unused.end()) sum += d[i];
    }
    if(s == sum){
        cout << "YES\n";
        cout << used.size() + unused.size() << '\n';
        for (auto x : used) {
            cout << 1 << " " << x + 1 << '\n';
        }
        for (auto x : unused) {
            cout << 2 << " " << x + 1 << '\n';
        }
        exit(0);
    }
}

void rec2(int i, long long d[]) {
    if (i == m) {
        check(d);
        return;
    }
    rec2(i + 1, d);
    unused.insert(i);
    rec2(i + 1, d);
    unused.erase(i);
}

void rec(int i) {
    if (i == n) {
        long long d[m];
        for (int j = 0; j < m; ++j) {
            long long sum = 0;
            for (int k = 0; k < n; ++k) {
                if (used.find(k) == used.end()) sum += a[k][j];
            }
            d[j] = sum;
        }
        rec2(0, d);
        return;
    }
    rec(i + 1);
    used.insert(i);
    rec(i + 1);
    used.erase(i);
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> m;
    a.resize(n);
    for (int i = 0; i < n; ++i) {
        a[i].resize(m);
        for (int j = 0; j < m; ++j) {
            cin >> a[i][j];
        }
    }
    cin >> s;
    for (int i = 0; i < n; ++i) {
        rec(i);
    }
    cout << "NO";
    return 0;
}