#include <bits/stdc++.h>

using namespace std;

vector<vector<int>> a;
int n, k;

void bfs(int i) {
    queue<int> q;
    q.push(i);
    int used[n];
    fill(used, used + n, -1);
    used[i] = 0;
    while (!q.empty()) {
        int x = q.front();
        q.pop();
        for (auto j: a[x]) {
            if (used[j] == -1) {
                used[j] = used[x] + 1;
                q.push(j);
            }
        }
    }
    sort(used, used + n);
    cout << used[n - 1 - k] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> n >> k >> t;
    int q = n;
    if (t == 0) {
        q = 1;
    }
    a.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;
        a[x].push_back(y);
        a[y].push_back(x);
    }
    for (int i = 0; i < q; ++i) {
        bfs(i);
    }
    return 0;
}