#include <bits/stdc++.h>

using namespace std;

vector<int> color;
vector<int> a;
vector<int> d((int) 1e6 + 10);

void dfs(int i, int colorful) {
    color[i] = colorful;
    for (int j = 0; j < a.size(); ++j) {
        if (color[j] == 0 && max(a[j], a[i]) % min(a[i], a[j]) == 0 && !d[max(a[j], a[i]) / min(a[i], a[j])]) {
            dfs(j, 3 - colorful);
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    color.resize(n);
    fill(d.begin(), d.end(), false);
    int c = (int) 1e6 + 10;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        color[i] = 0;
    }
    for (int i = 2; i < c; ++i) {
        if (!d[i]) {
            int x = i + i;
            while (x < c) {
                d[x] = true;
                x += i;
            }
        }
    }
    for (int i = 0; i < n; ++i) {
        if (color[i] == 0) dfs(i, 1);
    }
    for (int i = 0; i < n; ++i) {
        cout << color[i] << " ";
    }
    return 0;
}