#include <bits/stdc++.h>

using namespace std;

vector<int> color;
vector<int> a;
vector<int> d((int) 1e6 + 10);

void dfs(int i, int colorful) {
    color[i] = colorful;
    for (int j = i + 1; j < a.size(); ++j) {
        if (color[j] == 0 && max(a[j], a[i]) % min(a[i], a[j]) == 0 && !d[max(a[j], a[i]) / min(a[i], a[j])]) {
            color[j] = 3 - colorful;
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    a.resize(n);
    color.resize(n);
    fill(d.begin(), d.end(), false);
    int c = (int) 1e6 + 10;
    int mx = 0;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        color[i] = 0;
        mx = max(mx, a[i]);
    }
    d[1] = true;
    for (int i = 2; i < c; ++i) {
        if (!d[i]) {
            int x = i + i;
            while (x < c) {
                d[x] = true;
                x += i;
            }
        }
    }
    if (n <= 10) {
        for (int i = 0; i < n; ++i) {
            dfs(i, max(1, color[i]));
        }
        for (int i = 0; i < n; ++i) {
            cout << color[i] << " ";
        }
    } else if (mx <= 4) {
        for (int i = 0; i < n; ++i) {
            if (a[i] == 1 || a[i] == 4) {
                cout << "1 ";
            } else {
                cout << "2 ";
            }
        }
    } else {
        int b[n];
        for (int i = 0; i < n; ++i) {
            b[i] = a[i];
        }
        sort(b, b + n);
        map<int, int> ans;
        ans[b[0]] = 1;
        for (int i = 1; i < n; ++i) {
            if (b[i] == b[i - 1]) {
                ans[b[i]] = ans[b[i - 1]];
            } else {
                ans[b[i]] = 3 - ans[b[i - 1]];
            }
        }
        for (int i = 0; i < n; ++i) {
            cout << ans[a[i]] << " ";
        }
    }
    return 0;
}